#lang racket
(require rackunit)
(provide annotate)

; ---------------------------------------------------------------------------
; PROBLEM 1: annotate                                   (interface procedure)
; ---------------------------------------------------------------------------

(define example '(jerry george elaine kramer))

(define annotate-v0               ; but this adds a second parameter...
  (lambda (los position)
    (if (null? los)
        '()
        (cons (list (first los) position)
              (annotate-v0 (rest los) (+ position 1))))))

;; --------------------------------------------------------------------

(define annotate
  (lambda (los)
    (annotate-with-position los 1)))

(define annotate-with-position
  (lambda (los position)
    (if (null? los)
        '()
        (cons (list (first los) position)
              (annotate-with-position (rest los) (+ position 1))))))

;; --------------------------------------------------------------------

